aboutsummaryrefslogtreecommitdiff
path: root/git-merge.sh
diff options
context:
space:
mode:
authorJunio C Hamano <junkio@cox.net>2005-11-01 19:30:11 -0800
committerJunio C Hamano <junkio@cox.net>2005-11-03 14:55:10 -0800
commit123ee3ca7b57c32bb3ecd8cfede20dbb9dd5a8a8 (patch)
tree94780e95e47f6ca7f89c2a2b1e46671178583ed6 /git-merge.sh
parenta3114b3428595710d4719dd668531210af5993c9 (diff)
downloadgit-123ee3ca7b57c32bb3ecd8cfede20dbb9dd5a8a8.tar.gz
git-123ee3ca7b57c32bb3ecd8cfede20dbb9dd5a8a8.tar.xz
Add --no-commit to git-merge/git-pull.
With --no-commit flag, git-pull will perform the merge but pretends as if the merge needed a hand resolve even if automerge cleanly resolves, to give the user a chance to add further changes and edit the commit message. Signed-off-by: Junio C Hamano <junkio@cox.net>
Diffstat (limited to 'git-merge.sh')
-rwxr-xr-xgit-merge.sh28
1 files changed, 18 insertions, 10 deletions
diff --git a/git-merge.sh b/git-merge.sh
index 6ad96ebfb..dd104db7a 100755
--- a/git-merge.sh
+++ b/git-merge.sh
@@ -9,7 +9,7 @@ LF='
'
usage () {
- die "git-merge [-n] [-s <strategy>]... <merge-message> <head> <remote>+"
+ die "git-merge [-n] [--no-commit] [-s <strategy>]... <merge-message> <head> <remote>+"
}
# all_strategies='resolve recursive stupid octopus'
@@ -63,6 +63,8 @@ do
-n|--n|--no|--no-|--no-s|--no-su|--no-sum|--no-summ|\
--no-summa|--no-summar|--no-summary)
no_summary=t ;;
+ --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
+ no_commit=t ;;
-s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
--strateg=*|--strategy=*|\
-s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
@@ -111,18 +113,18 @@ done
common=$(git-show-branch --merge-base $head "$@")
echo "$head" >"$GIT_DIR/ORIG_HEAD"
-case "$#,$common" in
-*,'')
+case "$#,$common,$no_commit" in
+*,'',*)
# No common ancestors found. We need a real merge.
;;
-1,"$1")
+1,"$1",*)
# If head can reach all the merge then we are up to date.
# but first the most common case of merging one remote
echo "Already up-to-date."
dropsave
exit 0
;;
-1,"$head")
+1,"$head",*)
# Again the most common case of merging one remote.
echo "Updating from $head to $1."
git-update-index --refresh 2>/dev/null
@@ -132,11 +134,11 @@ case "$#,$common" in
dropsave
exit 0
;;
-1,?*"$LF"?*)
+1,?*"$LF"?*,*)
# We are not doing octopus and not fast forward. Need a
# real merge.
;;
-1,*)
+1,*,)
# We are not doing octopus, not fast forward, and have only
# one common. See if it is really trivial.
echo "Trying really trivial in-index merge..."
@@ -210,12 +212,18 @@ do
# Remember which strategy left the state in the working tree
wt_strategy=$strategy
- git-merge-$strategy $common -- "$head_arg" "$@" || {
+ git-merge-$strategy $common -- "$head_arg" "$@"
+ exit=$?
+ if test "$no_commit" = t && test "$exit" = 0
+ then
+ exit=1 ;# pretend it left conflicts.
+ fi
+
+ test "$exit" = 0 || {
# The backend exits with 1 when conflicts are left to be resolved,
# with 2 when it does not handle the given merge at all.
- exit=$?
if test "$exit" -eq 1
then
cnt=`{
@@ -272,4 +280,4 @@ do
done >"$GIT_DIR/MERGE_HEAD"
echo $merge_msg >"$GIT_DIR/MERGE_MSG"
-die "Automatic merge failed; fix up by hand"
+die "Automatic merge failed/prevented; fix up by hand"